<TeXmacs|1.0.7.14>

<style|tmdoc>

<\body>
  <tmdoc-title|More Complicated Examples with DrGeo>

  The following are examples shipped with DrGeo. Recall that, in DrGeo, you
  can move the figure using <verbatim|Ctrl+left-mouse-button>

  <\session|DrGeo|default>
    <\output>
      Plugin for version 1.1 of DrGeo. (c)2012 Adrian Soto, Hilaire Fernandes

      Please see instructions on the TeXmacs Menu
      help-\<gtr\>plugins-\<gtr\>DrGeo.
    </output>

    <\unfolded-io>
      DrGeo:
    <|unfolded-io>
      (new-figure "Spiral")

      \;

      (define (square p1 p2 p3 p4 n)

      \ \ \ (let* ((s1 \ (Segment "" extremities \ \ \ \ p1 p2))

      \ \ \ \ \ \ \ \ \ \ (s2 \ (Segment "" extremities \ \ \ \ p2 p3))

      \ \ \ \ \ \ \ \ \ \ (s3 \ (Segment "" extremities \ \ \ \ p3 p4))

      \ \ \ \ \ \ \ \ \ \ (s4 \ (Segment "" extremities \ \ \ \ p4 p1))

      \ \ \ \ \ \ \ \ \ \ (A \ \ (Point \ \ "" on-curve \ \ \ s1 \ \ 1/10))

      \ \ \ \ \ \ \ \ \ \ (B \ \ (Point \ \ "" on-curve \ \ \ s2 \ \ 1/10))

      \ \ \ \ \ \ \ \ \ \ (C \ \ (Point \ \ "" on-curve \ \ \ s3 \ \ 1/10))

      \ \ \ \ \ \ \ \ \ \ (D \ \ (Point \ \ "" on-curve \ \ \ s4 \ \ 1/10)))
      \ \ \ 

      \ \ \ \ \ (send A masked)

      \ \ \ \ \ (send B masked)

      \ \ \ \ \ (send C masked)

      \ \ \ \ \ (send D masked)

      \ (if (\<gtr\> n 0)

      \ \ \ \ \ (square \ A B C D (- n 1)))))

      \;

      \ (lets Point "M" free \ 5 \ 5)

      \ (lets Point "N" free -5 \ 5)

      \ (lets Point "O" free -5 -5)

      \ (lets Point "P" free \ 5 -5)

      \;

      \ (square M N O P 30)
    <|unfolded-io>
      \;
    </unfolded-io>

    <\input>
      DrGeo:
    <|input>
      (new-figure "")
    </input>
  </session>

  <\session|DrGeo|default>
    <\output>
      Plugin for version 1.1 of DrGeo. (c)2012 Adrian Soto, Hilaire Fernandes

      Please see instructions on the TeXmacs Menu
      help-\<gtr\>plugins-\<gtr\>DrGeo.
    </output>

    <\unfolded-io>
      DrGeo:
    <|unfolded-io>
      (new-figure "Baum")

      \;

      (lets Numeric "A1" free 2 2 +3.4)

      (lets Numeric "A2" free 2 3 -3.7)

      (lets Numeric "S1" free 2 4 +0.5)

      (lets Numeric "S2" free 2 5 +0.9)

      \;

      (define (dec n)

      \ \ (- n 1))

      \;

      (define (inc n)

      \ \ (+ n 1))

      \;

      (define (invisible p)

      \ \ (send p masked)

      \ \ p)

      \;

      (define (scalerot oP C a s)

      \ \ (let* ((sP (invisible (Point "" scale oP C s)))

      \ \ \ \ \ \ \ \ \ (rP (invisible (Point "" rotation sP C a))) )

      \ \ \ \ rP))

      \;

      (define (Zweig p0 p1 n)

      \ \ (Segment "" extremities p0 p1)

      \ \ (let* ((left-scale (if (odd? n) S1 S2))

      \ \ \ \ \ \ \ \ \ (left-angle A1)

      \ \ \ \ \ \ \ \ \ (right-scale (if (odd? n) S2 S1))

      \ \ \ \ \ \ \ \ \ (right-angle A2) )

      \ \ \ \ (if (\<gtr\> n 0)

      \ \ \ \ \ \ (begin

      \ \ \ \ \ \ \ \ (Zweig p1 (scalerot p0 p1 \ left-angle \ left-scale)
      (dec n))

      \ \ \ \ \ \ \ \ (Zweig p1 (scalerot p0 p1 right-angle right-scale) (dec
      n))))))

      \ \ \ \ \ \ \ \ 

      (lets Point "A" free -3 -2)

      (lets Point "B" free -3 0)

      \;

      (Zweig A B 6)
    <|unfolded-io>
      \;
    </unfolded-io>

    <\input>
      DrGeo:
    <|input>
      (new-figure "")
    </input>
  </session>

  <\session|DrGeo|default>
    <\output>
      Plugin for version 1.1 of DrGeo. (c)2012 Adrian Soto, Hilaire Fernandes

      Please see instructions on the TeXmacs Menu
      help-\<gtr\>plugins-\<gtr\>DrGeo.
    </output>

    <\folded-io>
      DrGeo:
    <|folded-io>
      (new-figure "tiling")

      (lets Point "A" free -4 -3)

      (lets Point "B" free 4 -3)

      (lets Numeric "N" free -0 -4 .5)

      (define (equilateral A B)

      \ \ (let ((C1 (Circle "" 2points B A))

      \ \ \ \ \ \ \ \ (C2 (Circle "" 2points A B)))

      \ \ \ \ \ \ \ \ (send C1 masked)

      \ \ \ \ \ \ \ \ (send C2 masked)

      \ \ \ \ \ \ \ \ (Point "" intersection C1 C2)))

      (define (half-hexagon A B)

      \ \ (let* ((M (Point "" middle-2pts A B))

      \ \ \ \ \ \ \ \ \ (R (equilateral A M))

      \ \ \ \ \ \ \ \ \ (S (equilateral M B)))

      \ \ \ \ \ \ \ (send M masked)

      \ \ \ \ \ \ \ (send R masked)

      \ \ \ \ \ \ \ (send S masked)

      \ \ \ \ \ \ \ (Segment "" extremities A R)

      \ \ \ \ \ \ \ (Segment "" extremities R S)

      \ \ \ \ \ \ \ (Segment "" extremities S B)

      \ \ \ \ \ \ \ (Segment "" extremities B A)

      \ \ \ \ \ \ \ (list A B S R)))\ 

      \;

      \;

      (define (newpoints A B C D)

      \ (let ((M (Point "" middle-2pts A B)))

      \ \ \ \ \ \ (send M masked)

      \ \ \ \ \ \ (list (Point "A1" scale A M N)

      \ \ \ \ \ \ \ \ \ \ \ \ (Point "B1" scale B M N)

      \ \ \ \ \ \ \ \ \ \ \ \ (Point "C1" scale C M N)

      \ \ \ \ \ \ \ \ \ \ \ \ (Point "D1" scale D M N))))

      \ \ \ \ \ \ \ \ \ \ \ \ 

      (define (substitute A B C D level levelcolor)

      \ \ \ \ (let* ((l (newpoints A B C D))

      \ \ \ \ \ \ \ \ \ \ \ (A1 (car l))

      \ \ \ \ \ \ \ \ \ \ \ (B1 (cadr l))

      \ \ \ \ \ \ \ \ \ \ \ (C1 (caddr l))

      \ \ \ \ \ \ \ \ \ \ \ (D1 (cadddr l))

      \ \ \ \ \ \ \ \ \ \ \ (S1 (Segment "" extremities D D1 ))

      \ \ \ \ \ \ \ \ \ \ \ (S2 (Segment "" extremities D1 C1))

      \ \ \ \ \ \ \ \ \ \ \ (S3 (Segment "" extremities C1 C ))

      \ \ \ \ \ \ \ \ \ \ \ (S4 (Segment "" extremities A1 D1))

      \ \ \ \ \ \ \ \ \ \ \ (S5 (Segment "" extremities B1 C1)))

      \ \ \ \ \ \ \ \ (send A1 masked)

      \ \ \ \ \ \ \ \ (send B1 masked)

      \ \ \ \ \ \ \ \ (send C1 masked)

      \ \ \ \ \ \ \ \ (send D1 masked)

      \ \ \ \ \ \ \ \ (send S1 color levelcolor)

      \ \ \ \ \ \ \ \ (send S2 color levelcolor)

      \ \ \ \ \ \ \ \ (send S3 color levelcolor)

      \ \ \ \ \ \ \ \ (send S4 color levelcolor)

      \ \ \ \ \ \ \ \ (send S5 color levelcolor)

      \ \ \ \ \ \ \ \ (send S1 thickness 2)

      \ \ \ \ \ \ \ \ (send S2 thickness 2)

      \ \ \ \ \ \ \ \ (send S3 thickness 2)

      \ \ \ \ \ \ \ \ (send S4 thickness 2)

      \ \ \ \ \ \ \ \ (send S5 thickness 2)

      \ \ \ \ \ \ \ \ (cond

      \ \ \ \ \ \ \ \ \ \ \ \ ((zero? level) #f)

      \ \ \ \ \ \ \ \ \ \ \ \ (else (substitute D A A1 D1 \ \ (- level 1)
      (modulo (+ levelcolor 2) 12))

      \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ (substitute C D D1 C1 \ \ (- level
      1) (modulo (+ levelcolor 2) 12))

      \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ (substitute B C C1 B1 \ \ (- level
      1) (modulo (+ levelcolor 2) 12))

      \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ (substitute A1 B1 C1 D1 (- level 1)
      (modulo (+ levelcolor 2) 12))))))

      \;

      \;

      (define (create n)\ 

      (let*

      \ \ ((l (half-hexagon A B))

      \ \ \ (C (caddr l))

      \ \ \ (D (cadddr l)))

      \ \ (substitute A B C D n 0)))

      \;

      (half-hexagon A B)

      (create 3)
    <|folded-io>
      \;
    </folded-io>

    <\input>
      DrGeo:
    <|input>
      (new-figure "")
    </input>
  </session>

  <\session|DrGeo|default>
    \;
  </session>
</body>

<\initial>
  <\collection>
    <associate|page-type|letter>
    <associate|prog-scripts|maxima>
  </collection>
</initial>